#### Beyond Linux® From Scratch (systemd Edition) - Version 10.1

### Chapter 12. System Utilities

- Prev

  Sysstat-12.5.3

- Next

  UDisks-2.9.2

- Up
- Home

# Systemd-247

## Introduction to systemd

While systemd was installed when building LFS, there are many features provided by the package that were not included in the initial installation because Linux-PAM was not yet installed. The systemd package needs to be rebuilt to provide a working systemd-logind service, which provides many additional features for dependent packages.

This package is known to build and work properly using an LFS-10.1 platform.

### Package Information

- Download (HTTP): https://github.com/systemd/systemd/archive/v247/systemd-247.tar.gz

- Download MD5 sum: b0d6e603b814908acc69db29bbfb023c

- Download size: 9.4 MB

- Estimated disk space required: 273 MB (with tests)

- Estimated build time: 2.1 SBU (with tests)

### Additional Downloads

- Required patch: http://www.linuxfromscratch.org/patches/blfs/10.1/systemd-247-upstream_fixes-1.patch

### systemd Dependencies

#### Required

Linux-PAM-1.5.1

#### Recommended Runtime Dependencies

Polkit-0.118

#### Optional

btrfs-progs-5.10.1, cURL-7.75.0, cryptsetup-2.3.4, git-2.30.1, GnuTLS-3.7.0, iptables-1.8.7, libgcrypt-1.9.2, libidn2-2.3.0, libpwquality-1.4.4, libseccomp-2.5.1, libxkbcommon-1.0.3, make-ca-1.7, pcre2-10.36, qemu-5.2.0, qrencode-4.1.1, Valgrind-3.16.1, zsh-5.8 (for the zsh completions), gnu-efi, kexec-tools, libfido2, libmicrohttpd, lz4, quota-tools and Sphinx

#### Optional (to rebuild the manual pages)

docbook-xml-4.5, docbook-xsl-1.79.2, libxslt-1.1.34, and lxml-4.6.2 (to build the index of systemd manual pages)

User Notes: http://wiki.linuxfromscratch.org/blfs/wiki/systemd

## Installation of systemd

Apply a patch to fix regressions in systemd-networkd and segmentation faults in systemctl:

    patch -Np1 -i ../systemd-247-upstream_fixes-1.patch

Remove an unneeded group, `render`, from the default udev rules:

    sed -i 's/GROUP="render"/GROUP="video"/' rules.d/50-udev-default.rules.in

Rebuild systemd by running the following commands:

    mkdir build &&
    cd    build &&

    meson --prefix=/usr                 \
          -Dblkid=true                  \
          -Dbuildtype=release           \
          -Ddefault-dnssec=no           \
          -Dfirstboot=false             \
          -Dinstall-tests=false         \
          -Dldconfig=false              \
          -Dman=auto                    \
          -Drootprefix=                 \
          -Drootlibdir=/lib             \
          -Dsplit-usr=true              \
          -Dsysusers=false              \
          -Drpmmacrosdir=no             \
          -Db_lto=false                 \
          -Dhomed=false                 \
          -Duserdb=false                \
          -Dmode=release                \
          -Dpamconfdir=/etc/pam.d       \
          -Ddocdir=/usr/share/doc/systemd-247 \
          ..                            &&

    ninja

### Note

For the best test results, make sure you run the testsuite from a system that is booted by the same systemd version you are rebuilding.

To test the results, issue: ninja test.

Now, as the `root` user:

    ninja install

## Command Explanations

`-Dpamconfdir=/etc/pam.d`: Forces the PAM files to be installed in /etc/pam.d rather than /usr/lib/pam.d.

`-Duserdb=false`: Removes a daemon that does not offer any use under a BLFS configuration. If you wish to enable the userdbd daemon, replace "false" with "true" in the above meson command.

`-Dhomed=false`: Remove a daemon that does not offer any use under a traditional BLFS configuration, especially using accounts created with useradd. To enable systemd-homed, first ensure that you have cryptsetup-2.3.4 and libpwquality-1.4.4, and then change "false" to "true" in the above meson command.

## Configuring systemd

The `/etc/pam.d/system-session` file needs to be modified and a new file needs to be created in order for systemd-logind to work correctly. Run the following commands as the `root` user:

    cat >> /etc/pam.d/system-session << "EOF"
    # Begin Systemd addition

    session  required    pam_loginuid.so
    session  optional    pam_systemd.so

    # End Systemd addition
    EOF

    cat > /etc/pam.d/systemd-user << "EOF"
    # Begin /etc/pam.d/systemd-user

    account  required    pam_access.so
    account  include     system-account

    session  required    pam_env.so
    session  required    pam_limits.so
    session  required    pam_unix.so
    session  required    pam_loginuid.so
    session  optional    pam_keyinit.so force revoke
    session  optional    pam_systemd.so

    auth     required    pam_deny.so
    password required    pam_deny.so

    # End /etc/pam.d/systemd-user
    EOF

### Warning

If upgrading from a previous version of systemd and an initrd is used for system boot, you should generate a new initrd before rebooting the system.

## Contents

A list of the installed files, along with their short descriptions can be found at ../../../../lfs/view/10.1/chapter08/systemd.html#contents-systemd.

Listed below are the newly installed libraries and directories along with short descriptions.

Installed Programs: homectl (if cryptsetup-2.3.4 is installed) and userdbctl (optionally)
Installed Libraries: pam_systemd.so (in `/lib/security`)
Installed Directories: None

### Short Descriptions

homectl | is a tool to create, remove, change, or inspect a home directory managed by systemd-homed; note that it's useless for the classic UNIX users and home directories which we are using in LFS/BLFS book
userdbctl | inspects users, groups, and group memberships
`pam_systemd.so` | is a PAM module used to register user sessions with the systemd login manager, systemd-logind

Last updated on 2021-02-22 17:02:40 -0800

- Prev

  Sysstat-12.5.3

- Next

  UDisks-2.9.2

- Up
- Home